##by NOPEname

##general
effect give @a saturation 1000000 0 true
kill @e[type=tnt]
gamemode adventure @a[gamemode=survival]
gamemode adventure @a[gamemode=creative,name=!NOPEname]
execute as @e[tag=isEnemy] at @s if block ~ ~-1 ~ black_concrete run tp @s ~ -100 ~
kill @e[type=minecraft:experience_orb]
xp set @a 0 levels
clear @a[gamemode=adventure] carved_pumpkin
execute as @e[type=item_frame] run data merge entity @s {Invulnerable:1b}
execute as @e[type=painting] run data merge entity @s {Invulnerable:1b}

execute as @a run function main:direction
execute as @a[scores={rejoin=1..}] run function main:rejoin
execute as @a[gamemode=adventure,scores={story=1..},tag=!ui_crash] run function main:ui/tick
execute as @a[gamemode=adventure,scores={story=1..},tag=ui_crash] run function main:ui/tick_crash



##ep 1 - end of map
execute if entity @a[x=-38,y=61,z=10194,distance=..10,scores={story=8..}] run schedule function event:overworld/spawn_end 5t



##region tick
execute if entity @a[x=145,y=67,z=179,distance=..120] run function main:region/lun_island



##tick speed
execute store result score tick tmp run worldborder get
scoreboard players operation tick tmp %= 10000000 const
worldborder set 50000000
worldborder set 60000000 10000



#trigger
execute as @a[gamemode=adventure] at @s if block ~ ~-2 ~ #minecraft:trigger if block ~ ~-3 ~ #minecraft:trigger if block ~ ~-4 ~ #minecraft:trigger run function main:trigger/tick
execute as @a[gamemode=adventure] at @s if block ~ ~-3 ~ #minecraft:trigger if block ~ ~-4 ~ #minecraft:trigger if block ~ ~-5 ~ #minecraft:trigger positioned ~ ~-1 ~ run function main:trigger/tick
execute as @a[gamemode=adventure] at @s unless block ~ ~-3 ~ #minecraft:trigger if block ~ 10 ~ #minecraft:trigger if block ~ 9 ~ #minecraft:trigger if block ~ 8 ~ #minecraft:trigger positioned ~ 12 ~ run function main:trigger/tick



##health
function main:max_health
execute as @a[scores={reg=1..}] run function main:reg


##spawn
execute as @a[tag=!spawn] run function main:spawn



##death
execute as @a[scores={time_since_death=1}] run function main:respawn



##damage
effect clear @a[scores={fall_timer=..0}] slow_falling
scoreboard players remove @a[scores={fall_timer=1..}] fall_timer 1
execute as @a at @s run function main:fall_damage

scoreboard players add @a on_fire 1
scoreboard players set @a[nbt={Fire:-20s}] on_fire 0
effect give @a[scores={on_fire=5}] minecraft:fire_resistance 1 0 true
scoreboard players set @a[scores={on_fire=30}] on_fire 0



#npc
team join no_collision @e[type=minecraft:villager]
effect give @e[type=minecraft:villager] slowness 1000000 100 true



#talk
execute as @a[scores={talk=1..}] at @s run function main:talk/tick
scoreboard players add @a[scores={talk_cool=1..}] talk_cool 1
scoreboard players set @a[scores={talk_cool=20..}] talk_cool 0



#fairy
execute as @e[type=bat] run data merge entity @s {BatFlags:0b}
execute at @e[type=bat,tag=fairy] positioned ~ ~0.2 ~ run particle totem_of_undying ~ ~ ~ 0 0 0 0.1 1
execute if entity @e[type=bat,tag=fairy] at @a[gamemode=adventure] positioned ~ ~1 ~ as @e[type=bat,tag=fairy,limit=1,distance=..1.5] at @s run function main:fairy/use



#bottle (fairy)
scoreboard players add @a[scores={catch_delay=1..}] catch_delay 1
scoreboard players set @a[scores={catch_delay=15..}] catch_delay 0



##items
scoreboard players set @a item 0
execute as @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick"}}] run function main:item/hold
execute as @a[scores={click=1..}] run function main:item/click

execute as @e[tag=boo,tag=ray,limit=1] at @s run function main:item/boomerang/tick
execute as @e[scores={boo_ai=1..}] run function main:item/boomerang/ai

execute as @a[gamemode=adventure,nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",tag:{type:"give_small_key"}}]}] run function main:give/small_key
execute as @a[gamemode=adventure,nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",tag:{type:"give_big_key"}}]}] run function main:give/big_key

execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:iron_sword"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:carrot_on_a_stick"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:shield"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:bow"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:string"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:flower_banner_pattern"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:brick"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:written_book"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}
execute as @e[type=item,tag=!shop,nbt={Item:{id:"minecraft:iron_ingot"}}] run data merge entity @s {PickupDelay:0,Invulnerable:1b}



#bomb & throw
execute as @e[tag=thrown] run data merge entity @s {Air:1s}
execute as @e[tag=thrown] run data merge entity @s {Air:0s}
execute if entity @e[tag=bomb] run function main:item/bomb/tick
scoreboard players remove @a[scores={bomb_cool=1..}] bomb_cool 1



#sword
execute as @a unless entity @s[scores={is_sneaking=1..}] run scoreboard players set @s sword 0
execute as @a[scores={sword_spin=0}] unless entity @s[scores={is_sneaking=1..}] run bossbar set minecraft:sword players
execute as @a unless entity @s[nbt={SelectedItem:{id:"minecraft:iron_sword"}}] run function main:sword/deselect
execute as @a[scores={sword=0}] run kill @e[tag=sword,tag=particle]
effect clear @a[scores={sword=..0}] weakness
effect clear @a[scores={sword=..0}] haste
execute as @a[gamemode=!spectator,nbt={SelectedItem:{id:"minecraft:iron_sword"}},scores={sword_spin=..0,is_sneaking=1..,sword=..30}] run function main:sword/hold
execute as @a[scores={sword_spin=1..}] run function main:sword/spin



##enemy
scoreboard players set @a morth_effect 0
execute if entity @e[tag=isEnemy] run function main:enemy/tick
execute as @e[tag=control,scores={boss_r=1..}] run function main:boss/running



#block
execute as @a[scores={is_sneaking=0},x_rotation=80..90] at @s align xyz positioned ~0.5 ~ ~0.5 if entity @e[tag=block,distance=..1.1] run function main:block/tick_push
execute as @a[scores={is_sneaking=1..},x_rotation=..79] at @s align xyz positioned ~0.5 ~ ~0.5 if entity @e[tag=block,distance=..2.1] run function main:block/tick_pull
execute as @e[tag=block] at @s if block ~ ~-1 ~ air run tp @s ~ ~-1 ~



##crawling
###execute as @a at @s if block ~ ~-2 ~ end_stone if block ~ ~1 ~ air align xz run particle minecraft:mycelium ~0.5 ~ ~0.5 0.25 0 0.25 1 1
######execute as @a at @s if block ~ ~-2 ~ end_stone unless block ~ ~1 ~ yellow_stained_glass run fill ~-3 ~ ~-3 ~3 ~3 ~3 air replace yellow_stained_glass
###execute as @a at @s unless block ~ ~1 ~ yellow_stained_glass run fill ~-3 ~ ~-3 ~3 ~3 ~3 air replace yellow_stained_glass
###execute as @a[scores={jump=1..}] at @s if block ~ ~-2 ~ end_stone if block ~ ~1 ~ yellow_stained_glass run fill ~ ~1 ~ ~ ~1 ~ air replace yellow_stained_glass
###execute as @a[x_rotation=80..90] at @s if block ~ ~-2 ~ end_stone if block ~ ~1 ~ air align xz run setblock ~ ~1 ~ yellow_stained_glass



#door
execute as @a at @s as @e[tag=is_door,distance=..2.50,scores={d_open=..10,d_lock=0}] at @s unless block ~1 ~ ~ water unless block ~-1 ~ ~ water unless block ~ ~ ~1 water unless block ~ ~ ~-1 water run scoreboard players add @s d_open 1
execute as @a at @s as @e[tag=is_door,distance=..2.50,scores={d_open=..10,d_lock=0}] at @s if block ~1 ~ ~ water run particle minecraft:dolphin ~ ~1.5 ~ 0.5 1 0.5 1 10
execute as @a at @s as @e[tag=is_door,distance=..2.50,scores={d_open=..10,d_lock=0}] at @s if block ~-1 ~ ~ water run particle minecraft:dolphin ~ ~1.5 ~ 0.5 1 0.5 1 10
execute as @a at @s as @e[tag=is_door,distance=..2.50,scores={d_open=..10,d_lock=0}] at @s if block ~ ~ ~1 water run particle minecraft:dolphin ~ ~1.5 ~ 0.5 1 0.5 1 10
execute as @a at @s as @e[tag=is_door,distance=..2.50,scores={d_open=..10,d_lock=0}] at @s if block ~ ~ ~-1 water run particle minecraft:dolphin ~ ~1.5 ~ 0.5 1 0.5 1 10
execute as @a at @s run scoreboard players set @e[tag=is_door,distance=..2.50] d_close 0
execute as @a at @s run scoreboard players set @e[tag=is_door,distance=2.51..] d_open 0
execute as @a at @s run scoreboard players add @e[tag=is_door,distance=2.51..,scores={d_close=..10}] d_close 1

execute as @e[tag=is_door,scores={d_open=1..10}] at @s run function main:door/open
execute as @e[tag=is_door,tag=is_north,scores={d_close=1..10}] at @s run function main:door/close_n
execute as @e[tag=is_door,tag=!is_north,scores={d_close=1..10}] at @s run function main:door/close

scoreboard players add @e[scores={d_lock=100..}] d_lock 1
scoreboard players set @e[scores={d_lock=105..}] d_lock 0



#switch
execute as @a[gamemode=adventure] at @s if block ~ ~ ~ minecraft:smooth_stone_slab[type=bottom] if block ~ ~-1 ~ pumpkin run function main:switch



#loot
execute as @a[gamemode=adventure] store success score @s tmp run clear @s #minecraft:loot 0
execute as @a[gamemode=adventure,scores={tmp=1..}] run function main:loot/tick
scoreboard players set @a[scores={rupees=1000..}] rupees 999
scoreboard players set @a[scores={lifes=1000..}] lifes 999



##scene
execute as @a[scores={scene=1..}] at @s run function event:scene/tick



#end
execute in minecraft:the_end run tp @a[nbt={Dimension:1}] 1 63 0



#music
execute if score tick tmp matches 4000.. as @a[scores={rejoin=0}] run function main:music/reset
scoreboard players operation @a[scores={music=1..}] music += tick tmp
execute as @a[scores={music=1000..},tag=m_stop] run function main:music/stop_pre
execute as @a[scores={music=110000..}] run function main:music/loop_tick



##exception
execute as @a[nbt={Pos:[0.5d,70.0d,0.5d],Rotation:[0.0f,0.0f]}] run function main:exception/missing_spawn
scoreboard players set player_count tmp 0
execute as @a run scoreboard players add player_count tmp 1
execute if score player_count tmp matches 2.. run function main:exception/player_count



##reset scores
scoreboard players set @a is_sneaking 0
scoreboard players set @a click 0
scoreboard players set @a jump 0